# Matrix4

#### new Cesium.Matrix4(column0Row0, column1Row0, column2Row0, column3Row0, column0Row1, column1Row1, column2Row1, column3Row1, column0Row2, column1Row2, column2Row2, column3Row2, column0Row3, column1Row3, column2Row3, column3Row3)
Core/Matrix4.js 53

A 4x4 matrix, indexable as a column-major order array. Constructor parameters are in row-major order for code readability.

Name | Type | Default | Description
--- | --- | --- | ---
`column0Row0` | Number | `0.0` | optional The value for column 0, row 0.
`column1Row0` | Number | `0.0` | optional The value for column 1, row 0.
`column2Row0` | Number | `0.0` | optional The value for column 2, row 0.
`column3Row0` | Number | `0.0` | optional The value for column 3, row 0.
`column0Row1` | Number | `0.0` | optional The value for column 0, row 1.
`column1Row1` | Number | `0.0` | optional The value for column 1, row 1.
`column2Row1` | Number | `0.0` | optional The value for column 2, row 1.
`column3Row1` | Number | `0.0` | optional The value for column 3, row 1.
`column0Row2` | Number | `0.0` | optional The value for column 0, row 2.
`column1Row2` | Number | `0.0` | optional The value for column 1, row 2.
`column2Row2` | Number | `0.0` | optional The value for column 2, row 2.
`column3Row2` | Number | `0.0` | optional The value for column 3, row 2.
`column0Row3` | Number | `0.0` | optional The value for column 0, row 3.
`column1Row3` | Number | `0.0` | optional The value for column 1, row 3.
`column2Row3` | Number | `0.0` | optional The value for column 2, row 3.
`column3Row3` | Number | `0.0` | optional The value for column 3, row 3.

##### See:

- Matrix4.fromColumnMajorArray
- Matrix4.fromRowMajorArray
- Matrix4.fromRotationTranslation
- Matrix4.fromTranslationRotationScale
- Matrix4.fromTranslationQuaternionRotationScale
- Matrix4.fromTranslation
- Matrix4.fromScale
- Matrix4.fromUniformScale
- Matrix4.fromCamera
- Matrix4.computePerspectiveFieldOfView
- Matrix4.computeOrthographicOffCenter
- Matrix4.computePerspectiveOffCenter
- Matrix4.computeInfinitePerspectiveOffCenter
- Matrix4.computeViewportTransformation
- Matrix4.computeView
- Matrix2
- Matrix3
- Packable

### Members

#### length : Number
Core/Matrix4.js 2619

Gets the number of items in the collection.

#### static constant Cesium.Matrix4.COLUMN0ROW0 : Number
Core/Matrix4.js 2490

The index into Matrix4 for column 0, row 0.

#### static constant Cesium.Matrix4.COLUMN0ROW1 : Number
Core/Matrix4.js 2498

The index into Matrix4 for column 0, row 1.

#### static constant Cesium.Matrix4.COLUMN0ROW2 : Number
Core/Matrix4.js 2506

The index into Matrix4 for column 0, row 2.

#### static constant Cesium.Matrix4.COLUMN0ROW3 : Number
Core/Matrix4.js 2514

The index into Matrix4 for column 0, row 3.

#### static constant Cesium.Matrix4.COLUMN1ROW0 : Number
Core/Matrix4.js 2522

The index into Matrix4 for column 1, row 0.

#### static constant Cesium.Matrix4.COLUMN1ROW1 : Number
Core/Matrix4.js 2530

The index into Matrix4 for column 1, row 1.

#### static constant Cesium.Matrix4.COLUMN1ROW2 : Number
Core/Matrix4.js 2538

The index into Matrix4 for column 1, row 2.

#### static constant Cesium.Matrix4.COLUMN1ROW3 : Number
Core/Matrix4.js 2546

The index into Matrix4 for column 1, row 3.

#### static constant Cesium.Matrix4.COLUMN2ROW0 : Number
Core/Matrix4.js 2554

The index into Matrix4 for column 2, row 0.

#### static constant Cesium.Matrix4.COLUMN2ROW1 : Number
Core/Matrix4.js 2562

The index into Matrix4 for column 2, row 1.

#### static constant Cesium.Matrix4.COLUMN2ROW2 : Number
Core/Matrix4.js 2570

The index into Matrix4 for column 2, row 2.

#### static constant Cesium.Matrix4.COLUMN2ROW3 : Number
Core/Matrix4.js 2578

The index into Matrix4 for column 2, row 3.

#### static constant Cesium.Matrix4.COLUMN3ROW0 : Number
Core/Matrix4.js 2586

The index into Matrix4 for column 3, row 0.

#### static constant Cesium.Matrix4.COLUMN3ROW1 : Number
Core/Matrix4.js 2594

The index into Matrix4 for column 3, row 1.

#### static constant Cesium.Matrix4.COLUMN3ROW2 : Number
Core/Matrix4.js 2602

The index into Matrix4 for column 3, row 2.

#### static constant Cesium.Matrix4.COLUMN3ROW3 : Number
Core/Matrix4.js 2610

The index into Matrix4 for column 3, row 3.

#### static constant Cesium.Matrix4.IDENTITY : Matrix4
Core/Matrix4.js 2474

An immutable Matrix4 instance initialized to the identity matrix.

#### static Cesium.Matrix4.packedLength : Number
Core/Matrix4.js 93

The number of elements used to pack the object into an array.

#### static constant Cesium.Matrix4.ZERO : Matrix4
Core/Matrix4.js 2482

An immutable Matrix4 instance initialized to the zero matrix.

### Methods

#### clone(result) → Matrix4
Core/Matrix4.js 2632

Duplicates the provided Matrix4 instance.

Name | Type | Description
--- | --- | ---
`result` | Matrix4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Matrix4 instance if one was not provided.

#### equals(right) → Boolean
Core/Matrix4.js 2643

Compares this matrix to the provided matrix componentwise and returns `true` if they are equal, `false` otherwise.

Name | Type | Description
--- | --- | ---
`right` | Matrix4 | optional The right hand side matrix.

##### Returns:

`true` if they are equal, `false` otherwise.

#### equalsEpsilon(right, epsilon) → Boolean
Core/Matrix4.js 2680

Compares this matrix to the provided matrix componentwise and returns `true` if they are within the provided epsilon, `false` otherwise.

Name | Type | Default | Description
--- | --- | --- | ---
`right` | Matrix4 |  | optional The right hand side matrix.
`epsilon` | Number | `0` | optional The epsilon to use for equality testing.

##### Returns:

`true` if they are within the provided epsilon, `false` otherwise.

#### toString() → String
Core/Matrix4.js 2690

Computes a string representing this Matrix with each row being on a separate line and in the format '(column0, column1, column2, column3)'.

##### Returns:

A string representing the provided Matrix with each row being on a separate line and in the format '(column0, column1, column2, column3)'.

#### static Cesium.Matrix4.abs(matrix, result) → Matrix4
Core/Matrix4.js 2039

Computes a matrix, which contains the absolute (unsigned) values of the provided matrix's elements.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix with signed elements.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.add(left, right, result) → Matrix4
Core/Matrix4.js 1422

Computes the sum of two matrices.

Name | Type | Description
--- | --- | ---
`left` | Matrix4 | The first matrix.
`right` | Matrix4 | The second matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.clone(matrix, result) → Matrix4
Core/Matrix4.js 177

Duplicates a Matrix4 instance.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to duplicate.
`result` | Matrix4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Matrix4 instance if one was not provided. (Returns undefined if matrix is undefined)

#### static Cesium.Matrix4.computeInfinitePerspectiveOffCenter(left, right, bottom, top, near, result) → Matrix4
Core/Matrix4.js 809

Computes a Matrix4 instance representing an infinite off center perspective transformation.

Name | Type | Description
--- | --- | ---
`left` | Number | The number of meters to the left of the camera that will be in view.
`right` | Number | The number of meters to the right of the camera that will be in view.
`bottom` | Number | The number of meters below of the camera that will be in view.
`top` | Number | The number of meters above of the camera that will be in view.
`near` | Number | The distance to the near plane in meters.
`result` | Matrix4 | The object in which the result will be stored.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.computeOrthographicOffCenter(left, right, bottom, top, near, far, result) → Matrix4
Core/Matrix4.js 707

Computes a Matrix4 instance representing an orthographic transformation matrix.

Name | Type | Description
--- | --- | ---
`left` | Number | The number of meters to the left of the camera that will be in view.
`right` | Number | The number of meters to the right of the camera that will be in view.
`bottom` | Number | The number of meters below of the camera that will be in view.
`top` | Number | The number of meters above of the camera that will be in view.
`near` | Number | The distance to the near plane in meters.
`far` | Number | The distance to the far plane in meters.
`result` | Matrix4 | The object in which the result will be stored.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.computePerspectiveFieldOfView(fovY, aspectRatio, near, far, result) → Matrix4
Core/Matrix4.js 660

Computes a Matrix4 instance representing a perspective transformation matrix.

Name | Type | Description
--- | --- | ---
`fovY` | Number | The field of view along the Y axis in radians.
`aspectRatio` | Number | The aspect ratio.
`near` | Number | The distance to the near plane in meters.
`far` | Number | The distance to the far plane in meters.
`result` | Matrix4 | The object in which the result will be stored.

##### Returns:

The modified result parameter.

##### Throws:

- DeveloperError : fovY must be in (0, PI].
- DeveloperError : aspectRatio must be greater than zero.
- DeveloperError : near must be greater than zero.
- DeveloperError : far must be greater than zero.

#### static Cesium.Matrix4.computePerspectiveOffCenter(left, right, bottom, top, near, far, result) → Matrix4
Core/Matrix4.js 760

Computes a Matrix4 instance representing an off center perspective transformation.

Name | Type | Description
--- | --- | ---
`left` | Number | The number of meters to the left of the camera that will be in view.
`right` | Number | The number of meters to the right of the camera that will be in view.
`bottom` | Number | The number of meters below of the camera that will be in view.
`top` | Number | The number of meters above of the camera that will be in view.
`near` | Number | The distance to the near plane in meters.
`far` | Number | The distance to the far plane in meters.
`result` | Matrix4 | The object in which the result will be stored.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.computeView(position, direction, up, right, result) → Matrix4
Core/Matrix4.js 918

Computes a Matrix4 instance that transforms from world space to view space.

Name | Type | Description
--- | --- | ---
`position` | Cartesian3 | The position of the camera.
`direction` | Cartesian3 | The forward direction.
`up` | Cartesian3 | The up direction.
`right` | Cartesian3 | The right direction.
`result` | Matrix4 | The object in which the result will be stored.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.computeViewportTransformation(viewport, nearDepthRange, farDepthRange, result) → Matrix4
Core/Matrix4.js 864

Computes a Matrix4 instance that transforms from normalized device coordinates to window coordinates.

Name | Type | Default | Description
--- | --- | --- | ---
`viewport` | Object | `{ x : 0.0, y : 0.0, width : 0.0, height : 0.0 }` | optional The viewport's corners as shown in Example 1.
`nearDepthRange` | Number | `0.0` | optional The near plane distance in window coordinates.
`farDepthRange` | Number | `1.0` | optional The far plane distance in window coordinates.
`result` | Matrix4 |  | optional The object in which the result will be stored.

##### Returns:

The modified result parameter.

##### Example:

    // Create viewport transformation using an explicit viewport and depth range.
    var m = Cesium.Matrix4.computeViewportTransformation({
        x : 0.0,
        y : 0.0,
        width : 1024.0,
        height : 768.0
    }, 0.0, 1.0, new Cesium.Matrix4());

#### static Cesium.Matrix4.equals(left, right) → Boolean
Core/Matrix4.js 2094

Compares the provided matrices componentwise and returns `true` if they are equal, `false` otherwise.

Name | Type | Description
--- | --- | ---
`left` | Matrix4 | optional The first matrix.
`right` | Matrix4 | optional The second matrix.

##### Returns:

`true` if left and right are equal, `false` otherwise.

##### Example:

    //compares two Matrix4 instances

    // a = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]

    // b = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]

    if(Cesium.Matrix4.equals(a,b)) {
         console.log("Both matrices are equal");
    } else {
         console.log("They are not equal");
    }

    //Prints "Both matrices are equal" on the console

#### static Cesium.Matrix4.equalsEpsilon(left, right, epsilon) → Boolean
Core/Matrix4.js 2156

Compares the provided matrices componentwise and returns `true` if they are within the provided epsilon, `false` otherwise.

Name | Type | Default | Description
--- | --- | --- | ---
`left` | Matrix4 |  | optional The first matrix.
`right` | Matrix4 |  | optional The second matrix.
`epsilon` | Number | `0` | optional The epsilon to use for equality testing.

##### Returns:

`true` if left and right are within the provided epsilon, `false` otherwise.

##### Example:

    //compares two Matrix4 instances

    // a = [10.5, 14.5, 18.5, 22.5]
    //     [11.5, 15.5, 19.5, 23.5]
    //     [12.5, 16.5, 20.5, 24.5]
    //     [13.5, 17.5, 21.5, 25.5]

    // b = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]

    if(Cesium.Matrix4.equalsEpsilon(a,b,0.1)){
         console.log("Difference between both the matrices is less than 0.1");
    } else {
         console.log("Difference between both the matrices is not less than 0.1");
    }

    //Prints "Difference between both the matrices is not less than 0.1" on the console

#### static Cesium.Matrix4.fromArray(array, startingIndex, result) → Matrix4
Core/Matrix4.js 243

Creates a Matrix4 from 16 consecutive elements in an array.

Name | Type | Default | Description
--- | --- | --- | ---
`array` | Array.<Number> |  | The array whose 16 consecutive elements correspond to the positions of the matrix. Assumes column-major order.
`startingIndex` | Number | `0` | optional The offset into the array of the first element, which corresponds to first column first row position in the matrix.
`result` | Matrix4 |  | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Matrix4 instance if one was not provided.

##### Example:

    // Create the Matrix4:
    // [1.0, 2.0, 3.0, 4.0]
    // [1.0, 2.0, 3.0, 4.0]
    // [1.0, 2.0, 3.0, 4.0]
    // [1.0, 2.0, 3.0, 4.0]

    var v = [1.0, 1.0, 1.0, 1.0, 2.0, 2.0, 2.0, 2.0, 3.0, 3.0, 3.0, 3.0, 4.0, 4.0, 4.0, 4.0];
    var m = Cesium.Matrix4.fromArray(v);

    // Create same Matrix4 with using an offset into an array
    var v2 = [0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 2.0, 2.0, 2.0, 2.0, 3.0, 3.0, 3.0, 3.0, 4.0, 4.0, 4.0, 4.0];
    var m2 = Cesium.Matrix4.fromArray(v2, 2);

#### static Cesium.Matrix4.fromCamera(camera, result) → Matrix4
Core/Matrix4.js 573

Computes a Matrix4 instance from a Camera.

Name | Type | Description
--- | --- | ---
`camera` | Camera | The camera to use.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

#### static Cesium.Matrix4.fromColumnMajorArray(values, result) → Matrix4
Core/Matrix4.js 252

Computes a Matrix4 instance from a column-major order array.

Name | Type | Description
--- | --- | ---
`values` | Array.<Number> | The column-major order array.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

#### static Cesium.Matrix4.fromRotationTranslation(rotation, translation, result) → Matrix4
Core/Matrix4.js 322

Computes a Matrix4 instance from a Matrix3 representing the rotation and a Cartesian3 representing the translation. 通过一个3x3的旋转矩阵和一个平移点取得一个四维矩阵

Name | Type | Default | Description
--- | --- | --- | ---
`rotation` | Matrix3 |  | The upper left portion of the matrix representing the rotation.
`translation` | Cartesian3 | `Cartesian3.ZERO` | optional The upper right portion of the matrix representing the translation.
`result` | Matrix4 |  | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

#### static Cesium.Matrix4.fromRowMajorArray(values, result) → Matrix4
Core/Matrix4.js 268

Computes a Matrix4 instance from a row-major order array. The resulting matrix will be in column-major order.

Name | Type | Description
--- | --- | ---
`values` | Array.<Number> | The row-major order array.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

#### static Cesium.Matrix4.fromScale(scale, result) → Matrix4
Core/Matrix4.js 491

Computes a Matrix4 instance representing a non-uniform scale.

Name | Type | Description
--- | --- | ---
`scale` | Cartesian3 | The x, y, and z scale factors.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

##### Example:

    // Creates
    //   [7.0, 0.0, 0.0, 0.0]
    //   [0.0, 8.0, 0.0, 0.0]
    //   [0.0, 0.0, 9.0, 0.0]
    //   [0.0, 0.0, 0.0, 1.0]
    var m = Cesium.Matrix4.fromScale(new Cesium.Cartesian3(7.0, 8.0, 9.0));

#### static Cesium.Matrix4.fromTranslation(translation, result) → Matrix4
Core/Matrix4.js 468

Creates a Matrix4 instance from a Cartesian3 representing the translation.

Name | Type | Description
--- | --- | ---
`translation` | Cartesian3 | The upper right portion of the matrix representing the translation.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

##### See:

- Matrix4.multiplyByTranslation

#### static Cesium.Matrix4.fromTranslationQuaternionRotationScale(translation, rotation, scale, result) → Matrix4
Core/Matrix4.js 386

Computes a Matrix4 instance from a translation, rotation, and scale (TRS) representation with the rotation represented as a quaternion.

Name | Type | Description
--- | --- | ---
`translation` | Cartesian3 | The translation transformation.
`rotation` | Quaternion | The rotation transformation.
`scale` | Cartesian3 | The non-uniform scale transformation.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

##### Example:

    var result = Cesium.Matrix4.fromTranslationQuaternionRotationScale(
      new Cesium.Cartesian3(1.0, 2.0, 3.0), // translation
      Cesium.Quaternion.IDENTITY,           // rotation
      new Cesium.Cartesian3(7.0, 8.0, 9.0), // scale
      result);

#### static Cesium.Matrix4.fromTranslationRotationScale(translationRotationScale, result) → Matrix4
Core/Matrix4.js 451

Creates a Matrix4 instance from a `TranslationRotationScale` instance.

Name | Type | Description
--- | --- | ---
`translationRotationScale` | TranslationRotationScale | The instance.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

#### static Cesium.Matrix4.fromUniformScale(scale, result) → Matrix4
Core/Matrix4.js 534

Computes a Matrix4 instance representing a uniform scale.

Name | Type | Description
--- | --- | ---
`scale` | Number | The uniform scale factor.
`result` | Matrix4 | optional The object in which the result will be stored, if undefined a new instance will be created.

##### Returns:

The modified result parameter, or a new Matrix4 instance if one was not provided.

##### Example:

    // Creates
    //   [2.0, 0.0, 0.0, 0.0]
    //   [0.0, 2.0, 0.0, 0.0]
    //   [0.0, 0.0, 2.0, 0.0]
    //   [0.0, 0.0, 0.0, 1.0]
    var m = Cesium.Matrix4.fromUniformScale(2.0);

#### static Cesium.Matrix4.getColumn(matrix, index, result) → Cartesian4
Core/Matrix4.js 1064

Retrieves a copy of the matrix column at the provided index as a Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`index` | Number | The zero-based index of the column to retrieve.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Throws:

- DeveloperError : index must be 0, 1, 2, or 3.

##### Examples:

    //returns a Cartesian4 instance with values from the specified column
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    //Example 1: Creates an instance of Cartesian
    var a = Cesium.Matrix4.getColumn(m, 2, new Cesium.Cartesian4());

    //Example 2: Sets values for Cartesian instance
    var a = new Cesium.Cartesian4();
    Cesium.Matrix4.getColumn(m, 2, a);

    // a.x = 12.0; a.y = 16.0; a.z = 20.0; a.w = 24.0;

#### static Cesium.Matrix4.getElementIndex(row, column) → Number
Core/Matrix4.js 1025

Computes the array index of the element at the provided row and column.

Name | Type | Description
--- | --- | ---
`row` | Number | The zero-based index of the row.
`column` | Number | The zero-based index of the column.

##### Returns:

The index of the element at the provided row and column.

##### Throws:

- DeveloperError : row must be 0, 1, 2, or 3.
- DeveloperError : column must be 0, 1, 2, or 3.

##### Example:

    var myMatrix = new Cesium.Matrix4();
    var column1Row0Index = Cesium.Matrix4.getElementIndex(1, 0);
    var column1Row0 = myMatrix[column1Row0Index];
    myMatrix[column1Row0Index] = 10.0;

#### static Cesium.Matrix4.getMatrix3(matrix, result) → Matrix3
Core/Matrix4.js 2224

Gets the upper left 3x3 matrix of the provided matrix.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`result` | Matrix3 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    // returns a Matrix3 instance from a Matrix4 instance

    // m = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]

    var b = new Cesium.Matrix3();
    Cesium.Matrix4.getMatrix3(m,b);

    // b = [10.0, 14.0, 18.0]
    //     [11.0, 15.0, 19.0]
    //     [12.0, 16.0, 20.0]

#### static Cesium.Matrix4.getMaximumScale(matrix) → Number
Core/Matrix4.js 1321

Computes the maximum scale assuming the matrix is an affine transformation. The maximum scale is the maximum length of the column vectors in the upper-left 3x3 matrix.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.

##### Returns:

The maximum scale.

#### static Cesium.Matrix4.getRow(matrix, index, result) → Cartesian4
Core/Matrix4.js 1222

Retrieves a copy of the matrix row at the provided index as a Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`index` | Number | The zero-based index of the row to retrieve.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Throws:

- DeveloperError : index must be 0, 1, 2, or 3.

##### Examples:

    //returns a Cartesian4 instance with values from the specified column
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    //Example 1: Returns an instance of Cartesian
    var a = Cesium.Matrix4.getRow(m, 2, new Cesium.Cartesian4());

    //Example 2: Sets values for a Cartesian instance
    var a = new Cesium.Cartesian4();
    Cesium.Matrix4.getRow(m, 2, a);

    // a.x = 18.0; a.y = 19.0; a.z = 20.0; a.w = 21.0;

#### static Cesium.Matrix4.getScale(matrix, result) → Cartesian3
Core/Matrix4.js 1299

Extracts the non-uniform scale assuming the matrix is an affine transformation.
取得一个非均匀比例尺，前提是是一个仿射变换矩阵

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.
`result` | Cartesian3 | The object onto which to store the result.

##### Returns:

The modified result parameter

#### static Cesium.Matrix4.getTranslation(matrix, result) → Cartesian3
Core/Matrix4.js 2190

Gets the translation portion of the provided matrix, assuming the matrix is an affine transformation matrix.
获取一个矩阵的平移信息，即x、y、z值，前提是该矩阵是仿射变换矩阵

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`result` | Cartesian3 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.inverse(matrix, result) → Matrix4
Core/Matrix4.js 2259

Computes the inverse of the provided matrix using Cramers Rule. If the determinant is zero, the matrix can not be inverted, and an exception is thrown. If the matrix is a proper rigid transformation, it is more efficient to invert it with `Matrix4.inverseTransformation`.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to invert.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Throws:

- RuntimeError : matrix is not invertible because its determinate is zero.

#### static Cesium.Matrix4.inverseTransformation(matrix, result) → Matrix4
Core/Matrix4.js 2401

Computes the inverse of the provided matrix assuming it is a proper rigid matrix, where the upper left 3x3 elements are a rotation matrix, and the upper three elements in the fourth column are the translation. The bottom row is assumed to be [0, 0, 0, 1]. The matrix is not verified to be in the proper form. This method is faster than computing the inverse for a general 4x4 matrix using `Matrix4.inverse`.
计算所提供的矩阵的逆矩阵，前提是一个适当的刚性矩阵。

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to invert.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.inverseTranspose(matrix, result) → Matrix4
Core/Matrix4.js 2459

Computes the inverse transpose of a matrix.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to transpose and invert.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.multiply(left, right, result) → Matrix4
Core/Matrix4.js 1334

Computes the product of two matrices.

Name | Type | Description
--- | --- | ---
`left` | Matrix4 | The first matrix.
`right` | Matrix4 | The second matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.multiplyByMatrix3(matrix, rotation, result) → Matrix4
Core/Matrix4.js 1583

Multiplies a transformation matrix (with a bottom row of `[0.0, 0.0, 0.0, 1.0]`) by a 3x3 rotation matrix. This is an optimization for `Matrix4.multiply(m, Matrix4.fromRotationTranslation(rotation), m);` with less allocations and arithmetic operations.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix on the left-hand side.
`rotation` | Matrix3 | The 3x3 rotation matrix on the right-hand side.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    // Instead of Cesium.Matrix4.multiply(m, Cesium.Matrix4.fromRotationTranslation(rotation), m);
    Cesium.Matrix4.multiplyByMatrix3(m, rotation, m);

#### static Cesium.Matrix4.multiplyByPoint(matrix, cartesian, result) → Cartesian3
Core/Matrix4.js 1861

Computes the product of a matrix and a `Cartesian3`. This is equivalent to calling `Matrix4.multiplyByVector` with a `Cartesian4` with a `w` component of 1, but returns a `Cartesian3` instead of a `Cartesian4`.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.
`cartesian` | Cartesian3 | The point.
`result` | Cartesian3 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    var p = new Cesium.Cartesian3(1.0, 2.0, 3.0);
    var result = Cesium.Matrix4.multiplyByPoint(matrix, p, new Cesium.Cartesian3());

#### static Cesium.Matrix4.multiplyByPointAsVector(matrix, cartesian, result) → Cartesian3
Core/Matrix4.js 1827

Computes the product of a matrix and a `Cartesian3`. This is equivalent to calling `Matrix4.multiplyByVector` with a `Cartesian4` with a `w` component of zero.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.
`cartesian` | Cartesian3 | The point.
`result` | Cartesian3 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    var p = new Cesium.Cartesian3(1.0, 2.0, 3.0);
    var result = Cesium.Matrix4.multiplyByPointAsVector(matrix, p, new Cesium.Cartesian3());
    // A shortcut for
    //   Cartesian3 p = ...
    //   Cesium.Matrix4.multiplyByVector(matrix, new Cesium.Cartesian4(p.x, p.y, p.z, 0.0), result);

#### static Cesium.Matrix4.multiplyByScalar(matrix, scalar, result) → Matrix4
Core/Matrix4.js 1905

Computes the product of a matrix and a scalar.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.
`scalar` | Number | The number to multiply by.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    //create a Matrix4 instance which is a scaled version of the supplied Matrix4
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    var a = Cesium.Matrix4.multiplyByScalar(m, -2, new Cesium.Matrix4());

    // m remains the same
    // a = [-20.0, -22.0, -24.0, -26.0]
    //     [-28.0, -30.0, -32.0, -34.0]
    //     [-36.0, -38.0, -40.0, -42.0]
    //     [-44.0, -46.0, -48.0, -50.0]

#### static Cesium.Matrix4.multiplyByScale(matrix, scale, result) → Matrix4
Core/Matrix4.js 1744

Multiplies an affine transformation matrix (with a bottom row of `[0.0, 0.0, 0.0, 1.0]`) by an implicit non-uniform scale matrix. This is an optimization for `Matrix4.multiply(m, Matrix4.fromUniformScale(scale), m);`, where `m` must be an affine matrix. This function performs fewer allocations and arithmetic operations.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The affine matrix on the left-hand side.
`scale` | Cartesian3 | The non-uniform scale on the right-hand side.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    // Instead of Cesium.Matrix4.multiply(m, Cesium.Matrix4.fromScale(scale), m);
    Cesium.Matrix4.multiplyByScale(m, scale, m);

##### See:

- Matrix4.fromScale
- Matrix4.multiplyByUniformScale

#### static Cesium.Matrix4.multiplyByTranslation(matrix, translation, result) → Matrix4
Core/Matrix4.js 1655

Multiplies a transformation matrix (with a bottom row of `[0.0, 0.0, 0.0, 1.0]`) by an implicit translation matrix defined by a `Cartesian3`. This is an optimization for `Matrix4.multiply(m, Matrix4.fromTranslation(position), m);` with less allocations and arithmetic operations.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix on the left-hand side.
`translation` | Cartesian3 | The translation on the right-hand side.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    // Instead of Cesium.Matrix4.multiply(m, Cesium.Matrix4.fromTranslation(position), m);
    Cesium.Matrix4.multiplyByTranslation(m, position, m);

#### static Cesium.Matrix4.multiplyByUniformScale(matrix, scale, result) → Matrix4
Core/Matrix4.js 1711

Multiplies an affine transformation matrix (with a bottom row of `[0.0, 0.0, 0.0, 1.0]`) by an implicit uniform scale matrix. This is an optimization for `Matrix4.multiply(m, Matrix4.fromUniformScale(scale), m);`, where `m` must be an affine matrix. This function performs fewer allocations and arithmetic operations.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The affine matrix on the left-hand side.
`scale` | Number | The uniform scale on the right-hand side.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    // Instead of Cesium.Matrix4.multiply(m, Cesium.Matrix4.fromUniformScale(scale), m);
    Cesium.Matrix4.multiplyByUniformScale(m, scale, m);

##### See:

- Matrix4.fromUniformScale
- Matrix4.multiplyByScale

#### static Cesium.Matrix4.multiplyByVector(matrix, cartesian, result) → Cartesian4
Core/Matrix4.js 1787

Computes the product of a matrix and a column vector.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix.
`cartesian` | Cartesian4 | The vector.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.multiplyTransformation(left, right, result) → Matrix4
Core/Matrix4.js 1501

Computes the product of two matrices assuming the matrices are affine transformation matrices, where the upper left 3x3 elements are any matrix, and the upper three elements in the fourth column are the translation. The bottom row is assumed to be [0, 0, 0, 1]. The matrix is not verified to be in the proper form. This method is faster than computing the product for general 4x4 matrices using `Matrix4.multiply`.

Name | Type | Description
--- | --- | ---
`left` | Matrix4 | The first matrix.
`right` | Matrix4 | The second matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    var m1 = new Cesium.Matrix4(1.0, 6.0, 7.0, 0.0, 2.0, 5.0, 8.0, 0.0, 3.0, 4.0, 9.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    var m2 = Cesium.Transforms.eastNorthUpToFixedFrame(new Cesium.Cartesian3(1.0, 1.0, 1.0));
    var m3 = Cesium.Matrix4.multiplyTransformation(m1, m2, new Cesium.Matrix4());

#### static Cesium.Matrix4.negate(matrix, result) → Matrix4
Core/Matrix4.js 1953

Computes a negated copy of the provided matrix.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to negate.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    //create a new Matrix4 instance which is a negation of a Matrix4
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    var a = Cesium.Matrix4.negate(m, new Cesium.Matrix4());

    // m remains the same
    // a = [-10.0, -11.0, -12.0, -13.0]
    //     [-14.0, -15.0, -16.0, -17.0]
    //     [-18.0, -19.0, -20.0, -21.0]
    //     [-22.0, -23.0, -24.0, -25.0]

#### static Cesium.Matrix4.pack(value, array, startingIndex) → Array.<Number>
Core/Matrix4.js 104

Stores the provided instance into the provided array.

Name | Type | Default | Description
--- | --- | --- | ---
`value` | Matrix4 |  | The value to pack.
`array` | Array.<Number> |  | The array to pack into.
`startingIndex` | Number | `0` | optional The index into the array at which to start packing the elements.

##### Returns:

The array that was packed into

#### static Cesium.Matrix4.setColumn(matrix, index, cartesian, result) → Matrix4
Core/Matrix4.js 1113

Computes a new matrix that replaces the specified column in the provided matrix with the provided Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`index` | Number | The zero-based index of the column to set.
`cartesian` | Cartesian4 | The Cartesian whose values will be assigned to the specified column.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Throws:

- DeveloperError : index must be 0, 1, 2, or 3.

##### Example:

    //creates a new Matrix4 instance with new column values from the Cartesian4 instance
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    var a = Cesium.Matrix4.setColumn(m, 2, new Cesium.Cartesian4(99.0, 98.0, 97.0, 96.0), new Cesium.Matrix4());

    // m remains the same
    // a = [10.0, 11.0, 99.0, 13.0]
    //     [14.0, 15.0, 98.0, 17.0]
    //     [18.0, 19.0, 97.0, 21.0]
    //     [22.0, 23.0, 96.0, 25.0]

#### static Cesium.Matrix4.setRow(matrix, index, cartesian, result) → Matrix4
Core/Matrix4.js 1270

Computes a new matrix that replaces the specified row in the provided matrix with the provided Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`index` | Number | The zero-based index of the row to set.
`cartesian` | Cartesian4 | The Cartesian whose values will be assigned to the specified row.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Throws:

- DeveloperError : index must be 0, 1, 2, or 3.

##### Example:

    //create a new Matrix4 instance with new row values from the Cartesian4 instance
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    var a = Cesium.Matrix4.setRow(m, 2, new Cesium.Cartesian4(99.0, 98.0, 97.0, 96.0), new Cesium.Matrix4());

    // m remains the same
    // a = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [99.0, 98.0, 97.0, 96.0]
    //     [22.0, 23.0, 24.0, 25.0]

#### static Cesium.Matrix4.setScale(matrix, scale, result) → Matrix4
Core/Matrix4.js 1183

Computes a new matrix that replaces the scale with the provided scale. This assumes the matrix is an affine transformation. 通过一个点的x、y、z值，更改当前矩阵三个轴的比例尺，并返回这个矩阵。

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`scale` | Cartesian3 | The scale that replaces the scale of the provided matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.setTranslation(matrix, translation, result) → Matrix4
Core/Matrix4.js 1142

Computes a new matrix that replaces the translation in the rightmost column of the provided matrix with the provided translation. This assumes the matrix is an affine transformation.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use.
`translation` | Cartesian3 | The translation that replaces the translation of the provided matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.subtract(left, right, result) → Matrix4
Core/Matrix4.js 1456

Computes the difference of two matrices.

Name | Type | Description
--- | --- | ---
`left` | Matrix4 | The first matrix.
`right` | Matrix4 | The second matrix.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Matrix4.toArray(matrix, result) → Array.<Number>
Core/Matrix4.js 965

Computes an Array from the provided Matrix4 instance. The array will be in column-major order.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to use..
`result` | Array.<Number> | optional The Array onto which to store the result.

##### Returns:

The modified Array parameter or a new Array instance if one was not provided.

##### Example:

    //create an array from an instance of Matrix4
    // m = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]
    var a = Cesium.Matrix4.toArray(m);

    // m remains the same
    //creates a = [10.0, 11.0, 12.0, 13.0, 14.0, 15.0, 16.0, 17.0, 18.0, 19.0, 20.0, 21.0, 22.0, 23.0, 24.0, 25.0]

#### static Cesium.Matrix4.transpose(matrix, result) → Matrix4
Core/Matrix4.js 2000

Computes the transpose of the provided matrix.

Name | Type | Description
--- | --- | ---
`matrix` | Matrix4 | The matrix to transpose.
`result` | Matrix4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

##### Example:

    //returns transpose of a Matrix4
    // m = [10.0, 11.0, 12.0, 13.0]
    //     [14.0, 15.0, 16.0, 17.0]
    //     [18.0, 19.0, 20.0, 21.0]
    //     [22.0, 23.0, 24.0, 25.0]

    var a = Cesium.Matrix4.transpose(m, new Cesium.Matrix4());

    // m remains the same
    // a = [10.0, 14.0, 18.0, 22.0]
    //     [11.0, 15.0, 19.0, 23.0]
    //     [12.0, 16.0, 20.0, 24.0]
    //     [13.0, 17.0, 21.0, 25.0]

#### static Cesium.Matrix4.unpack(array, startingIndex, result) → Matrix4
Core/Matrix4.js 140

Retrieves an instance from a packed array.

Name | Type | Default | Description
--- | --- | --- | ---
`array` | Array.<Number> |  | The packed array.
`startingIndex` | Number | `0` | optional The starting index of the element to be unpacked.
`result` | Matrix4 |  | optional The object into which to store the result.

##### Returns:

The modified result parameter or a new Matrix4 instance if one was not provided.